//+------------------------------------------------------------------+
//| sto x  rsi                                                       |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//mod 2008 fxtsd   ki
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 1
#property indicator_width2 1

extern int Kperiod= 5;
extern int Dperiod= 3;
extern int slowing= 3;
extern int MAmethod= 1;
extern int price_field  = 1;
extern int line_mode    = 0;

extern string note_method_ = "MAmethod: SMA0 EMA1 SMMA2 LWMA3"; 
extern string price_field_ = "0- Low/High  1- Close/Close" ;
extern string line_mode___ = "0- main 1- signal line" ;

extern int RSI_period      = 5;
extern int RSI_price       = 0;
extern string  RSI_price__ = "0C 1O 2H 3L 4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";

extern int SignalOfset = 1;

//--- input parameters

double UpBuffer[];
double DnBuffer[];

double Range, AvgRange;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_ARROW,EMPTY);
   SetIndexStyle(1,DRAW_ARROW,EMPTY);
  
  
   SetIndexArrow(0,233);
   SetIndexArrow(1,234);

   SetIndexLabel(0,"Up Signal");
   SetIndexLabel(1,"Down Signal");

   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);


   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
  
   for(int i=0; i<limit;i++)
   {       
 
       
      int counter=i;
      Range=0;
      AvgRange=0;

      for (counter=i ;counter<=i+9;counter++)
       {
      AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
       }
      Range=AvgRange/10;

 
 
  double sto  = iStochastic(NULL,0,Kperiod,Dperiod,slowing,MAmethod,price_field,line_mode,i) ;
  double sto1 = iStochastic(NULL,0,Kperiod,Dperiod,slowing,MAmethod,price_field,line_mode,i+1) ;


  double rsi    =iRSI(NULL,0,RSI_period,RSI_price,i);
  double rsi1   =iRSI(NULL,0,RSI_period,RSI_price,i+1);


      if( sto1<rsi1 && sto>rsi)
  
      {  
        UpBuffer[i] = iLow(Symbol(),0,i)-(Range+SignalOfset*Point);
        DnBuffer[i] = EMPTY_VALUE;
      }
      
      else 
      
      if( sto1>rsi1 && sto<rsi)
      {
        UpBuffer[i] = EMPTY_VALUE;
        DnBuffer[i] = iHigh(Symbol(),0,i)+(Range+SignalOfset*Point);
      }
     
      else
      {
        DnBuffer[i] = EMPTY_VALUE;
        UpBuffer[i] = EMPTY_VALUE;
      }
 
   }

   return(0);
  }



